# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test_56
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2023/8/4 15:54
# Description:
# 
# ---------------------------------------------------------------------------
import pytest
from APIAutoTest02.common.read_excel import ReadExcel


class TestBPM:

    @pytest.mark.parametrize("req_method, url, mime, case_data, expect_data, sql_type, sql_sentence, update_key", ReadExcel().get_data())
    def test_bpm(self, db_fix, req_fix, req_method, url, mime, case_data, expect_data, sql_type, sql_sentence, update_key):
        print(req_method, url, mime, case_data, expect_data, sql_type, sql_sentence, update_key)
        # 请求之前的操作
        # 1：判断sql语句的类型是否为delete，如果为delete，先执行删除的sql语句，再发送请求
        if sql_type == "delete":
            # 执行删除的sql语句，使用DB类对象，调用delete方法执行删除语句.DB类对象就是自定义固件db_fix
            db_fix.delete(sql_sentence)
            # 再发送请求
            result = req_fix.request_all(method=req_method, url=url, mime=mime, case_data=case_data)

        # 2：判断sql语句的类型是否为select，如果为select，执行查询sql语句，并获取查询的结果，将查询的结果更新到用例数据中
        elif sql_type == "select":
            # 执行查询sql语句，使用DB类对象，调用select方法执行查询的sql语句，并接收查询的结果
            select_result = db_fix.select(sql_sentence)
            # 将查询结果更新到用例数据中
            case_data[update_key] = select_result
            print(case_data)
            # 再发送请求
            result = req_fix.request_all(method=req_method, url=url, mime=mime, case_data=case_data)

        # 3: 判断sql语句类型是否为select|delete或为delete|select，如果是就需要执行查询和删除。
        elif sql_type == "select|delete" or sql_type == "delete|select":
            # 先执行删除的sql语句。# 这里的sql语句存放在一个字典中， 字典的格式为：{"delete":"删除sql语句", "select":"查询sql语句"}
            # 执行删除的sql语句，使用DB类对象，调用delete方法执行删除语句.DB类对象就是自定义固件db_fix
            db_fix.delete(sql_sentence["delete"])
            # 再执行查询的sql语句
            # 执行查询sql语句，使用DB类对象，调用select方法执行查询的sql语句，并接收查询的结果
            select_result = db_fix.select(sql_sentence["select"])
            # 将查询的结果更新到用例数据中。
            case_data[update_key] = select_result
            # 再发送请求
            result = req_fix.request_all(method=req_method, url=url, mime=mime, case_data=case_data)

        else:
            result = req_fix.request_all(method=req_method, url=url, mime=mime, case_data=case_data)

        # 请求之后的操作
        print("="*100)
        print("服务器返回数据", result.json())
        # 断言
        try:
            # 取出期望数据的key，对比 期望数据key对应的value和服务器返回数据key对应的value
            for key in expect_data.keys():
                assert expect_data[key] == result.json().get(key)
        except:
            raise AssertionError("断言失败")
        else:
            print("断言成功")


if __name__ == '__main__':
    pytest.main()